// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from grbl_msgs:action/SendGcodeCmd.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "grbl_msgs/action/send_gcode_cmd.hpp"


#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__TRAITS_HPP_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "grbl_msgs/action/detail/send_gcode_cmd__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_Goal & msg,
  std::ostream & out)
{
  out << "{";
  // member: command
  {
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: command
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "command: ";
    rosidl_generator_traits::value_to_yaml(msg.command, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_Goal & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_Goal & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_Goal & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_Goal>()
{
  return "grbl_msgs::action::SendGcodeCmd_Goal";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_Goal>()
{
  return "grbl_msgs/action/SendGcodeCmd_Goal";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_Goal>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_Goal>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_Result & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_Result & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_Result & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_Result & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_Result>()
{
  return "grbl_msgs::action::SendGcodeCmd_Result";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_Result>()
{
  return "grbl_msgs/action/SendGcodeCmd_Result";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_Result>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_Result>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_Result>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_Feedback & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_Feedback & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_Feedback & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_Feedback & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_Feedback>()
{
  return "grbl_msgs::action::SendGcodeCmd_Feedback";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_Feedback>()
{
  return "grbl_msgs/action/SendGcodeCmd_Feedback";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_Feedback>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_Feedback>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'goal'
#include "grbl_msgs/action/detail/send_gcode_cmd__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_SendGoal_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: goal
  {
    out << "goal: ";
    to_flow_style_yaml(msg.goal, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: goal
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal:\n";
    to_block_style_yaml(msg.goal, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_SendGoal_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_SendGoal_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_SendGoal_Request & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>()
{
  return "grbl_msgs::action::SendGcodeCmd_SendGoal_Request";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>()
{
  return "grbl_msgs/action/SendGcodeCmd_SendGoal_Request";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeCmd_Goal>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeCmd_Goal>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_SendGoal_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: accepted
  {
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << ", ";
  }

  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: accepted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "accepted: ";
    rosidl_generator_traits::value_to_yaml(msg.accepted, out);
    out << "\n";
  }

  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_SendGoal_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_SendGoal_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_SendGoal_Response & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>()
{
  return "grbl_msgs::action::SendGcodeCmd_SendGoal_Response";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>()
{
  return "grbl_msgs/action/SendGcodeCmd_SendGoal_Response";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>
  : std::integral_constant<bool, has_fixed_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>
  : std::integral_constant<bool, has_bounded_size<builtin_interfaces::msg::Time>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_SendGoal_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_SendGoal_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_SendGoal_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_SendGoal_Event & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_SendGoal_Event>()
{
  return "grbl_msgs::action::SendGcodeCmd_SendGoal_Event";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_SendGoal_Event>()
{
  return "grbl_msgs/action/SendGcodeCmd_SendGoal_Event";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Event>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>::value && has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_SendGoal_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_SendGoal>()
{
  return "grbl_msgs::action::SendGcodeCmd_SendGoal";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_SendGoal>()
{
  return "grbl_msgs/action/SendGcodeCmd_SendGoal";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal>
  : std::integral_constant<
    bool,
    has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>::value &&
    has_fixed_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>::value
  >
{
};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal>
  : std::integral_constant<
    bool,
    has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>::value &&
    has_bounded_size<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>::value
  >
{
};

template<>
struct is_service<grbl_msgs::action::SendGcodeCmd_SendGoal>
  : std::true_type
{
};

template<>
struct is_service_request<grbl_msgs::action::SendGcodeCmd_SendGoal_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grbl_msgs::action::SendGcodeCmd_SendGoal_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_GetResult_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_GetResult_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_GetResult_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_GetResult_Request & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_GetResult_Request>()
{
  return "grbl_msgs::action::SendGcodeCmd_GetResult_Request";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_GetResult_Request>()
{
  return "grbl_msgs/action/SendGcodeCmd_GetResult_Request";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult_Request>
  : std::integral_constant<bool, has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Request>
  : std::integral_constant<bool, has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_GetResult_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'result'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_cmd__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_GetResult_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: result
  {
    out << "result: ";
    to_flow_style_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result:\n";
    to_block_style_yaml(msg.result, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_GetResult_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_GetResult_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_GetResult_Response & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_GetResult_Response>()
{
  return "grbl_msgs::action::SendGcodeCmd_GetResult_Response";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_GetResult_Response>()
{
  return "grbl_msgs/action/SendGcodeCmd_GetResult_Response";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult_Response>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeCmd_Result>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Response>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeCmd_Result>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_GetResult_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
// already included above
// #include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_GetResult_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_GetResult_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_GetResult_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_GetResult_Event & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_GetResult_Event>()
{
  return "grbl_msgs::action::SendGcodeCmd_GetResult_Event";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_GetResult_Event>()
{
  return "grbl_msgs/action/SendGcodeCmd_GetResult_Event";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Event>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Request>::value && has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_GetResult_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_GetResult>()
{
  return "grbl_msgs::action::SendGcodeCmd_GetResult";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_GetResult>()
{
  return "grbl_msgs/action/SendGcodeCmd_GetResult";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult>
  : std::integral_constant<
    bool,
    has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult_Request>::value &&
    has_fixed_size<grbl_msgs::action::SendGcodeCmd_GetResult_Response>::value
  >
{
};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult>
  : std::integral_constant<
    bool,
    has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Request>::value &&
    has_bounded_size<grbl_msgs::action::SendGcodeCmd_GetResult_Response>::value
  >
{
};

template<>
struct is_service<grbl_msgs::action::SendGcodeCmd_GetResult>
  : std::true_type
{
};

template<>
struct is_service_request<grbl_msgs::action::SendGcodeCmd_GetResult_Request>
  : std::true_type
{
};

template<>
struct is_service_response<grbl_msgs::action::SendGcodeCmd_GetResult_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"
// Member 'feedback'
// already included above
// #include "grbl_msgs/action/detail/send_gcode_cmd__traits.hpp"

namespace grbl_msgs
{

namespace action
{

inline void to_flow_style_yaml(
  const SendGcodeCmd_FeedbackMessage & msg,
  std::ostream & out)
{
  out << "{";
  // member: goal_id
  {
    out << "goal_id: ";
    to_flow_style_yaml(msg.goal_id, out);
    out << ", ";
  }

  // member: feedback
  {
    out << "feedback: ";
    to_flow_style_yaml(msg.feedback, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SendGcodeCmd_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: goal_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_id:\n";
    to_block_style_yaml(msg.goal_id, out, indentation + 2);
  }

  // member: feedback
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "feedback:\n";
    to_block_style_yaml(msg.feedback, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SendGcodeCmd_FeedbackMessage & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace action

}  // namespace grbl_msgs

namespace rosidl_generator_traits
{

[[deprecated("use grbl_msgs::action::to_block_style_yaml() instead")]]
inline void to_yaml(
  const grbl_msgs::action::SendGcodeCmd_FeedbackMessage & msg,
  std::ostream & out, size_t indentation = 0)
{
  grbl_msgs::action::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use grbl_msgs::action::to_yaml() instead")]]
inline std::string to_yaml(const grbl_msgs::action::SendGcodeCmd_FeedbackMessage & msg)
{
  return grbl_msgs::action::to_yaml(msg);
}

template<>
inline const char * data_type<grbl_msgs::action::SendGcodeCmd_FeedbackMessage>()
{
  return "grbl_msgs::action::SendGcodeCmd_FeedbackMessage";
}

template<>
inline const char * name<grbl_msgs::action::SendGcodeCmd_FeedbackMessage>()
{
  return "grbl_msgs/action/SendGcodeCmd_FeedbackMessage";
}

template<>
struct has_fixed_size<grbl_msgs::action::SendGcodeCmd_FeedbackMessage>
  : std::integral_constant<bool, has_fixed_size<grbl_msgs::action::SendGcodeCmd_Feedback>::value && has_fixed_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct has_bounded_size<grbl_msgs::action::SendGcodeCmd_FeedbackMessage>
  : std::integral_constant<bool, has_bounded_size<grbl_msgs::action::SendGcodeCmd_Feedback>::value && has_bounded_size<unique_identifier_msgs::msg::UUID>::value> {};

template<>
struct is_message<grbl_msgs::action::SendGcodeCmd_FeedbackMessage>
  : std::true_type {};

}  // namespace rosidl_generator_traits


namespace rosidl_generator_traits
{

template<>
struct is_action<grbl_msgs::action::SendGcodeCmd>
  : std::true_type
{
};

template<>
struct is_action_goal<grbl_msgs::action::SendGcodeCmd_Goal>
  : std::true_type
{
};

template<>
struct is_action_result<grbl_msgs::action::SendGcodeCmd_Result>
  : std::true_type
{
};

template<>
struct is_action_feedback<grbl_msgs::action::SendGcodeCmd_Feedback>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits


#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__TRAITS_HPP_
